/// <reference types="node" />
import { BitObject } from '.';
import { BitObjectList } from './bit-object-list';
import Ref from './ref';
export declare type ObjectItem = {
    ref: Ref;
    buffer: Buffer;
    type?: string;
    scope?: string;
};
export declare const FETCH_FORMAT_OBJECT_LIST = "ObjectList";
export declare class ObjectList {
    objects: ObjectItem[];
    constructor(objects?: ObjectItem[]);
    count(): number;
    static mergeMultipleInstances(objectLists: ObjectList[]): ObjectList;
    mergeObjectList(objectList: ObjectList): void;
    static fromJsonString(jsonStr: string): ObjectList;
    toJsonString(): string;
    toTar(): NodeJS.ReadableStream;
    static fromTar(packStream: NodeJS.ReadableStream): Promise<ObjectList>;
    static extractScopeAndHash(name: string): {
        scope?: string;
        ref: Ref;
    };
    combineScopeAndHash(objectItem: ObjectItem): string;
    addIfNotExist(objectItems: ObjectItem[]): void;
    toBitObjects(): Promise<BitObjectList>;
    static fromBitObjects(bitObjects: BitObject[]): Promise<ObjectList>;
    addScopeName(scopeName: string): void;
    splitByScopeName(): {
        [scopeName: string]: ObjectList;
    };
    toConsoleLog(): void;
}
