"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.sort.js");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _pMap() {
  const data = _interopRequireDefault(require("p-map"));

  _pMap = function () {
    return data;
  };

  return data;
}

function _pMapSeries() {
  const data = _interopRequireDefault(require("p-map-series"));

  _pMapSeries = function () {
    return data;
  };

  return data;
}

function path() {
  const data = _interopRequireWildcard(require("path"));

  path = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _removeEmptyDir() {
  const data = _interopRequireDefault(require("./remove-empty-dir"));

  _removeEmptyDir = function () {
    return data;
  };

  return data;
}

/**
 * This function will remove the list of files from fs
 * Then go to the folder of each file and remove it as well if it's empty
 */
var removeFilesAndEmptyDirsRecursively = async function removeFilesAndEmptyDirsRecursively(filesPaths) {
  const dirs = filesPaths.map(filePath => path().dirname(filePath));

  _logger().default.info(`remove-files-and-empty-dirs-recursively deleting the following paths: ${filesPaths.join(', ')}`);

  await (0, _pMap().default)(filesPaths, filePath => _fsExtra().default.remove(filePath), {
    concurrency: _constants().CONCURRENT_IO_LIMIT
  }); // Sorting it to make sure we will delete the inner dirs first

  const sortedDirs = dirs.sort().reverse();
  await (0, _pMapSeries().default)(sortedDirs, dir => (0, _removeEmptyDir().default)(dir));
  return true;
};

exports.default = removeFilesAndEmptyDirsRecursively;